VERSION 5.00
Begin VB.Form FrmMain 
   AutoRedraw      =   -1  'True
   Caption         =   "Mike's  raycaster"
   ClientHeight    =   5700
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7545
   Icon            =   "FrmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   380
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   503
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picBoard 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      Height          =   4935
      Left            =   0
      ScaleHeight     =   329
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   441
      TabIndex        =   0
      Top             =   0
      Width           =   6615
      Begin VB.Timer tmrKeys 
         Interval        =   20
         Left            =   0
         Top             =   0
      End
   End
End
Attribute VB_Name = "FrmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Mike's Raycaster v0.04
' A demonstration of raycasting in Visual Basic

' FrmMain.frm: Display and input.

' Copyright (c) 2008-2010 Michael Billington <michael.billington@gmail.com>
'
' Permission is hereby granted, free of charge, to any person obtaining a copy
' of this software and associated documentation files (the "Software"), to deal
' in the Software without restriction, including without limitation the rights
' to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
' copies of the Software, and to permit persons to whom the Software is
' furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in
' all copies or substantial portions of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
' IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
' FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
' AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
' LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
' OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
' THE SOFTWARE.

Option Explicit
Dim rawr As Boolean

Private Sub Form_Activate()
    ResetChar
    rawr = True
    Do
        DoEvents
        If rawr Then
            Render3D picBoard
        Else
            Render2D picBoard
        End If
    Loop
End Sub
Sub ResetChar()
        LoadMap App.path & "\data\map1.txt"
        cView.Angle = 3 * pi / 2
        picBoard.SetFocus
End Sub
Private Sub Form_Resize()
    picBoard.height = Me.ScaleHeight
    picBoard.width = Me.ScaleWidth
End Sub

Private Sub picBoard_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeySpace Then rawr = Not rawr
    If KeyAscii = vbKeyReturn Then
        ResetChar
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Die
End Sub

Private Sub tmrKeys_Timer()
    If GetKeyState(vbKeyLeft) And key_pressed Then
        cView.Angle = normalise_angle(cView.Angle - pi / 56)
    ElseIf GetKeyState(vbKeyRight) And key_pressed Then
        cView.Angle = normalise_angle(cView.Angle + pi / 56)
    End If
    
    If GetKeyState(vbKeyUp) And key_pressed Then
        cView.X = cView.X + 20 * Cos(cView.Angle)
        cView.Y = cView.Y + 20 * Sin(cView.Angle)
    ElseIf GetKeyState(vbKeyDown) And key_pressed Then
        cView.X = cView.X - 20 * Cos(cView.Angle)
        cView.Y = cView.Y - 20 * Sin(cView.Angle)
    End If
    
    
End Sub
